#ifndef __MAP2WRAM_H
#define __MAP2WRAM_H

bool write_MAP_HEADER(string filename, int level_ID, int mesh_tot);


bool write_MAP_HEADER(string filename, int level_ID, int mesh_tot)
{
   cout << "\nCONVERTING HEADER FILE TO NEW FORMAT\n";
   ofstream file(filename, ios::out);

    if (!file.is_open()) return false;

    file << "#ifndef __LEVEL" << level_ID << "_H__\n";
    file << "#define __LEVEL" << level_ID << "_H__\n\n";
    file << "static POINT *pointArray" << level_ID << ";\n";
    file << "static POLYGON *polygonArray" << level_ID << ";\n";
    file << "static ATTR *attributeArray" << level_ID << ";\n";
    file << "static jo_3d_mesh *" << "MeshLevel" << level_ID << "[" << mesh_tot << "];\n\n";
    file << "static void ToPoint" << level_ID << "(Uint16 index, FIXED x, FIXED y, FIXED z)\n{\n	pointArray[index][X] = x;\n	pointArray[index][Y] = y;\n	pointArray[index][Z] = z;\n}\n\n";
    file << "static void LoadPoints" << level_ID << "(void)\n{\n";

        /*********************
        Right now it doesn't support multiple meshes, I will have to fix this
        *********************/


        for (int i=0; i<mesh_tot; i++)
        {
            for (unsigned int ii=0; ii<mesh_array[i].data.nbPoint; ii++)
            {
                file  << "ToPoint" << level_ID << "(" << ii << ", " << mesh_array[i].data.pntbl[ii][0] << ", " << mesh_array[i].data.pntbl[ii][1] << ", " << mesh_array[i].data.pntbl[ii][2] << ");\n";
            }
            file << "}\n\n";

            file << "static void AssignToPolygon(Uint16 index, FIXED x, FIXED y, FIXED z, Uint16 vertex1, Uint16 vertex2, Uint16 vertex3, Uint16 vertex4)\n{\n";
            file << "	polygonArray[index].norm[X] = x;\n	polygonArray[index].norm[Y] = y;\n	polygonArray[index].norm[Z] = z;\n	polygonArray[index].Vertices[0] = vertex1;\n";
            file << "	polygonArray[index].Vertices[1] = vertex2;\n	polygonArray[index].Vertices[2] = vertex3;\n	polygonArray[index].Vertices[3] = vertex4;\n}\n\n";

            file << "static void LoadPolygons(void)\n{\n";
            for (unsigned int ii = 0; ii<mesh_array[i].data.nbPolygon; ii++)
            {
                file << "AssignToPolygon(" << ii << ", " << mesh_array[i].data.pltbl[ii].norm[0] << ", " << mesh_array[i].data.pltbl[ii].norm[1] << ", " << mesh_array[i].data.pltbl[ii].norm[2] << ", ";
                file << mesh_array[i].data.pltbl[ii].Vertices[0] << ", " << mesh_array[i].data.pltbl[ii].Vertices[1] << ", " << mesh_array[i].data.pltbl[ii].Vertices[2] << ", " << mesh_array[i].data.pltbl[ii].Vertices[3] << ");\n";
            }
            file << "}\n\n";

            file << "static void AssignToAttribute(Uint16 index, Uint8 n1, Uint8 n2, Uint16 n3, Uint16 n4, Uint16 n5, Uint16 n6, int n7, Uint8 n8)\n{\n	ATTR tempAttribute = ATTRIBUTE(n1,n2,n3,n4,n5,n6,n7,n8);\n";
            file << "	attributeArray[index].flag = tempAttribute.flag;\n	attributeArray[index].sort = tempAttribute.sort;\n	attributeArray[index].texno = tempAttribute.texno;\n	attributeArray[index].atrb = tempAttribute.atrb;\n";
            file << "	attributeArray[index].colno = tempAttribute.colno;\n	attributeArray[index].gstb = tempAttribute.gstb;\n	attributeArray[index].dir = tempAttribute.dir;\n}\n\n";

            file << "static void LoadAttributes(void)\n{\n";

            for (unsigned int ii = 0; ii<mesh_array[i].data.nbPolygon; ii++)
            {
                file << "AssignToAttribute(" << ii << ", ";                //file << mesh_array[i].data.attbl[ii].flag << ", ";
                file << "Single_Plane, ";                //file << mesh_array[i].data.attbl[ii].sort << ", ";
                file << "SORT_MAX, ";
                file << mesh_array[i].data.attbl[ii].texno << ", ";                //file << mesh_array[i].data.attbl[ii].colno << " | ";
                file << "No_Palet, CL32KRGB | ";                //file << mesh_array[i].data.attbl[ii].gstb << " | " << ", " << << ");\n";
                file << "No_Gouraud, CL32KRGB | ";                //file << mesh_array[i].data.attbl[ii].dir << ");\n";
                file << "MESHoff, sprNoflip, UseNearClip);\n";
            }
            file << "}\n\n";

            file << "void * Load" << "Level" << level_ID << "_Mesh" << i << "(void * startAddress)\n{\n	pointArray = (POINT*) startAddress;\n	LoadPoints();\n	polygonArray = (POLYGON*) (pointArray + sizeof (POINT)*" << mesh_array[i].data.nbPoint << ");\n	LoadPolygons();\n";
            file << "	attributeArray = (ATTR*) (polygonArray + sizeof (POLYGON)*" << mesh_array[i].data.nbPolygon << ");\n	LoadAttributes();\n";

            file << "	MeshLevel" << level_ID << "[" << i << "] = (jo_3d_mesh*) (attributeArray + sizeof (ATTR)*"<< mesh_array[i].data.nbPolygon << ");\n";
            file << "	MeshLevel" << level_ID << "[" << i << "]->data.pntbl = pointArray;";
            file << "	MeshLevel" << level_ID << "[" << i << "]->data.nbPoint = " << mesh_array[i].data.nbPoint << ";\n"; //Could also use sizeof(PointArray)/sizeof(POINT) for more flexibility
            file << "	MeshLevel" << level_ID << "[" << i << "]->data.pltbl = polygonArray;\n";
            file << "	MeshLevel" << level_ID << "[" << i << "]->data.nbPolygon = " << mesh_array[i].data.nbPolygon << ";\n";
            file << "	MeshLevel" << level_ID << "[" << i << "]->data.attbl = attributeArray;\n";
            file << "	// Return the next address after the mesh. This is useful if you want to load another mesh (or anything else for that matter) to memory after this.\n";
            file << "	return (void*) (MeshLevel" << level_ID << "[" << i << "] + sizeof (jo_3d_mesh));\n}\n";

            file << "static __jo_force_inline void display_Level_" << level_ID << "(void)\n{\n";
            for (int ii=0; ii<mesh_tot; ii++)
            {
                file <<   "    jo_3d_mesh_draw(MeshLevel" << level_ID << "[" << ii << "]);\n";
            }
            file << "}\n\n";

            file << "static __jo_force_inline void load_Textures_Level_" << level_ID << "(unsigned int first_texture_id)\n{\n";
            file << "     int i = 0;\n     int ii = 0;\n     for (i=0; i <" << mesh_tot<<"; i++)\n     {\n     ";
            file << "   for (ii=0; ii<MeshLevel" << level_ID << "[i].data.nbPolygon;ii++)\n        {\n     ";
            file << "        MeshLevel" << level_ID << "[i].data.attbl[ii].texno += first_texture_id;\n        }\n     }\n\n";

        }


    file << "#endif\n";
    file.close();


    return true;
}





#endif // __MAP2WRAM_H
