#ifndef __MAPBSP_H
#define __MAPBSP_H

/***********
* These functions subdivide the map in smaller objects
* TODO : Fix bugs as it's hit and miss right now, with maps with single objects not always subdividing properly
***********/

_BB_Hitbox ReturnPolyBounds(_temp_mesh * currentMesh, int idx)
{
    _BB_Hitbox tempBB;
    tempBB.MinValue.x = 2147483647; tempBB.MinValue.y = 2147483647; tempBB.MinValue.z = 2147483647;
    tempBB.MaxValue.x = -2147483647;  tempBB.MaxValue.y = -2147483647;  tempBB.MaxValue.z = -2147483647;

    for (int i=0; i<4; i++)
    {
        if (currentMesh->data.pntbl[currentMesh->data.pltbl[idx].Vertices[i]][0] < tempBB.MinValue.x) tempBB.MinValue.x = currentMesh->data.pntbl[currentMesh->data.pltbl[idx].Vertices[i]][0];
        if (currentMesh->data.pntbl[currentMesh->data.pltbl[idx].Vertices[i]][1] < tempBB.MinValue.y) tempBB.MinValue.y = currentMesh->data.pntbl[currentMesh->data.pltbl[idx].Vertices[i]][1];
        if (currentMesh->data.pntbl[currentMesh->data.pltbl[idx].Vertices[i]][2] < tempBB.MinValue.z) tempBB.MinValue.z = currentMesh->data.pntbl[currentMesh->data.pltbl[idx].Vertices[i]][2];
        if (currentMesh->data.pntbl[currentMesh->data.pltbl[idx].Vertices[i]][0] > tempBB.MaxValue.x) tempBB.MaxValue.x = currentMesh->data.pntbl[currentMesh->data.pltbl[idx].Vertices[i]][0];
        if (currentMesh->data.pntbl[currentMesh->data.pltbl[idx].Vertices[i]][1] > tempBB.MaxValue.y) tempBB.MaxValue.y = currentMesh->data.pntbl[currentMesh->data.pltbl[idx].Vertices[i]][1];
        if (currentMesh->data.pntbl[currentMesh->data.pltbl[idx].Vertices[i]][2] > tempBB.MaxValue.z) tempBB.MaxValue.z = currentMesh->data.pntbl[currentMesh->data.pltbl[idx].Vertices[i]][2];
    }

    return tempBB;
}


int AddPoint(_temp_mesh * newMesh, POINT CurrentPoint)
{
    for (unsigned int i=0; i< newMesh->data.nbPoint; i++)
    {
        if ((newMesh->data.pntbl[i][0] == CurrentPoint[0])&& (newMesh->data.pntbl[i][1]== CurrentPoint[1]) && (newMesh->data.pntbl[i][2]== CurrentPoint[2]))
            {
                return i;
            }
    }

    newMesh->data.pntbl[newMesh->data.nbPoint][0] = CurrentPoint[0];
    newMesh->data.pntbl[newMesh->data.nbPoint][1] = CurrentPoint[1];
    newMesh->data.pntbl[newMesh->data.nbPoint][2] = CurrentPoint[2];
    newMesh->data.nbPoint ++;
    return (newMesh->data.nbPoint - 1);
}

#define tot_temp_mesh (512)
    _temp_mesh TempMesh[tot_temp_mesh];
/*** BETA : Subdivide the meshes into smaller meshes. I'm not even sure it will work ***/
int subdivideObj(int targetx, int targety, int targetz)
{
    _BB_Hitbox TempMeshBB={0};
    _BB_Hitbox NewMeshBound[tot_temp_mesh];

    int idx=0;

   for (int i=0; i<tot_temp_mesh; i++) {TempMesh[i].data.nbPoint=0; TempMesh[i].data.nbPolygon=0; }
    if (targetx<1) targetx=1;
    if (targety<1) targety=1;
    if (targetz<1) targetz=1;

    TempMeshBB.MaxValue.x = -2147483647;  TempMeshBB.MaxValue.y = -2147483647;  TempMeshBB.MaxValue.z = -2147483647;
    TempMeshBB.MinValue.x = 2147483647;   TempMeshBB.MinValue.y = 2147483647;   TempMeshBB.MinValue.z = 2147483647;

    /* Create global boundaries */
    for (int i=0; i<MeshPtr+1; i++)
    {
        for (unsigned int ii=0; ii<ObjMesh[i].data.nbPoint; ii++)
        {
            if (ObjMesh[i].data.pntbl[ii][0] > TempMeshBB.MaxValue.x) TempMeshBB.MaxValue.x=ObjMesh[i].data.pntbl[ii][0];
            if (ObjMesh[i].data.pntbl[ii][0] < TempMeshBB.MinValue.x) TempMeshBB.MinValue.x=ObjMesh[i].data.pntbl[ii][0];
            if (ObjMesh[i].data.pntbl[ii][1] > TempMeshBB.MaxValue.y) TempMeshBB.MaxValue.y=ObjMesh[i].data.pntbl[ii][1];
            if (ObjMesh[i].data.pntbl[ii][1] < TempMeshBB.MinValue.y) TempMeshBB.MinValue.y=ObjMesh[i].data.pntbl[ii][1];
            if (ObjMesh[i].data.pntbl[ii][2] > TempMeshBB.MaxValue.z) TempMeshBB.MaxValue.z=ObjMesh[i].data.pntbl[ii][2];
            if (ObjMesh[i].data.pntbl[ii][2] < TempMeshBB.MinValue.z) TempMeshBB.MinValue.z=ObjMesh[i].data.pntbl[ii][2];
        }
    }


    idx=0;
    for (int x=0; x<targetx; x++)
    {
        for (int z=0; z<targetz; z++)
        {
            for (int y=0; y<targety; y++)
            {
                //TempMesh[idx].data.nbPoint=0;TempMesh[idx].data.nbPolygon=0;


                  NewMeshBound[idx].MinValue.x = TempMeshBB.MinValue.x + ((TempMeshBB.MaxValue.x-TempMeshBB.MinValue.x)*x/targetx);
                  NewMeshBound[idx].MinValue.y = TempMeshBB.MinValue.y + ((TempMeshBB.MaxValue.y-TempMeshBB.MinValue.y)*y/targety);
                  NewMeshBound[idx].MinValue.z = TempMeshBB.MinValue.z + ((TempMeshBB.MaxValue.z-TempMeshBB.MinValue.z)*z/targetz);

                  NewMeshBound[idx].MaxValue.x = TempMeshBB.MinValue.x + ((TempMeshBB.MaxValue.x-TempMeshBB.MinValue.x)*(x+1)/targetx);
                  NewMeshBound[idx].MaxValue.y = TempMeshBB.MinValue.y + ((TempMeshBB.MaxValue.y-TempMeshBB.MinValue.y)*(y+1)/targety);
                  NewMeshBound[idx].MaxValue.z = TempMeshBB.MinValue.z + ((TempMeshBB.MaxValue.z-TempMeshBB.MinValue.z)*(z+1)/targetz);
                  idx++;
            }
        }
    }

    cout << "IDX.....................\n................\n" << idx << "\n***************";
    cout << "MeshPTR.....................\n................\n" << MeshPtr << "\n***************";
    for (int i=0; i<MeshPtr+1; i++)
    {
        for (unsigned int ii=0; ii<ObjMesh[i].data.nbPolygon; ii++)
        {
            for (idx=0; idx<(targetx*targety*targetz); idx++)
            {
                //bool inBounds = false;
                _BB_Hitbox tempBB = ReturnPolyBounds(&ObjMesh[i], ii);

                if ((tempBB.MinValue.x >= NewMeshBound[idx].MinValue.x) && (tempBB.MinValue.x < NewMeshBound[idx].MaxValue.x)
                    && (tempBB.MinValue.y >= NewMeshBound[idx].MinValue.y) && (tempBB.MinValue.y < NewMeshBound[idx].MaxValue.y)
                    && (tempBB.MinValue.z >= NewMeshBound[idx].MinValue.z) && (tempBB.MinValue.z < NewMeshBound[idx].MaxValue.z))
                    {
                        int totPol=TempMesh[idx].data.nbPolygon;
                        for (int j=0; j<4; j++)
                        {
                            int tempPoint= AddPoint(&TempMesh[idx], (ObjMesh[i].data.pntbl[ObjMesh[i].data.pltbl[ii].Vertices[j]]));

                            TempMesh[idx].data.pltbl[totPol].Vertices[j] = tempPoint;
                        }

                    //    for (int j=0; j<3; j++)
                     //   {
                            TempMesh[idx].data.pltbl[totPol].norm[0] = ObjMesh[i].data.pltbl[ii].norm[0];
                            TempMesh[idx].data.pltbl[totPol].norm[1] = ObjMesh[i].data.pltbl[ii].norm[1];
                            TempMesh[idx].data.pltbl[totPol].norm[2] = ObjMesh[i].data.pltbl[ii].norm[2];
                            TempMesh[idx].data.attbl[totPol] = ObjMesh[i].data.attbl[ii];
                        //     ObjMesh[MeshPtr].data.pltbl[ObjMesh[MeshPtr].data.nbPolygon].norm[0]
                      //  }

                        TempMesh[idx].data.nbPolygon++;
                    }


                /*if ((ObjMesh[i].data.pntbl[ObjMesh[i].data.pltbl[ii].Vertices[j]][0] < NewMeshBound[idx].MaxValue.x) ||  (ObjMesh[i].data.pntbl[ObjMesh[i].data.pltbl[ii].Vertices[j]][0] < NewMeshBound[idx].MinValue.x)) inBounds=false;
                if ((ObjMesh[i].data.pntbl[ObjMesh[i].data.pltbl[ii].Vertices[j]][1] > NewMeshBound[idx].MaxValue.y) ||  (ObjMesh[i].data.pntbl[ObjMesh[i].data.pltbl[ii].Vertices[j]][1] < NewMeshBound[idx].MinValue.y)) inBounds=false;
                if ((ObjMesh[i].data.pntbl[ObjMesh[i].data.pltbl[ii].Vertices[j]][2] > NewMeshBound[idx].MaxValue.z) ||  (ObjMesh[i].data.pntbl[ObjMesh[i].data.pltbl[ii].Vertices[j]][2] < NewMeshBound[idx].MinValue.z)) inBounds=false;*/
            }


        }
    }

    idx=0;
    int tot = targetx*targety*targetz;
    for (int i=0; i<tot; i++)
    {
        if (TempMesh[i].data.nbPolygon==0)
        {
            cout << "Mesh No." << i << " has no polygons. ";
            /*for (int ii=i; ii<(tot-1); ii++)
            {
            }*/
        }
        else
        {
            for (unsigned int ii=0; ii<TempMesh[i].data.nbPoint; ii++)
            {
                ObjMesh[idx].data.pntbl[ii][0] = TempMesh[i].data.pntbl[ii][0];
                ObjMesh[idx].data.pntbl[ii][1] = TempMesh[i].data.pntbl[ii][1];
                ObjMesh[idx].data.pntbl[ii][2] = TempMesh[i].data.pntbl[ii][2];
            }
            for (unsigned int ii=0; ii<TempMesh[i].data.nbPolygon; ii++)
            {
                ObjMesh[idx].data.attbl[ii] = TempMesh[i].data.attbl[ii];
                ObjMesh[idx].data.pltbl[ii] = TempMesh[i].data.pltbl[ii];
            }
            ObjMesh[idx].data.nbPoint = TempMesh[i].data.nbPoint;
            ObjMesh[idx].data.nbPolygon = TempMesh[i].data.nbPolygon;
            idx++;
        }
    }
    MeshPtr = idx-1;




    ofstream ofile("TEST_DIV.txt", ios::out);
    if (!ofile.is_open()) return -1;

    for (int i=0; i< (targetx*targety*targetz); i++)
    {
        ofile << "\n\n//BSP mesh No." << i << " MinX " << NewMeshBound[i].MinValue.x/65536 << " MaxX " << NewMeshBound[i].MaxValue.x/65536; // << "\n";   //<< "\n   Nb poly : " << TempMesh[i].data.nbPolygon << ", Nb points : " << TempMesh[i].data.nbPoint << "\n\n";
        ofile << " MinY " << NewMeshBound[i].MinValue.y/65536 << " MaxY " << NewMeshBound[i].MaxValue.y/65536;
        ofile << " MinZ " << NewMeshBound[i].MinValue.z/65536 << " MaxZ " << NewMeshBound[i].MaxValue.z/65536 << "\n\n";
        ofile << "POINT PointMesh" << i << "[]= \n{\n";
        for (unsigned int ii=0; ii< TempMesh[i].data.nbPoint; ii++)
        {
            ofile << "{" << TempMesh[i].data.pntbl[ii][0]/65536 << ", " << TempMesh[i].data.pntbl[ii][1]/65536 << ", " << TempMesh[i].data.pntbl[ii][2]/65536 <<  "},\n";
        }
        ofile << "};\n\n";

        ofile << "POLYGON PolygonMesh" << i << "[]= \n{\n";
        for (unsigned int ii=0; ii<TempMesh[i].data.nbPolygon; ii++)
        {
            ofile << "{NORMALS{" << TempMesh[i].data.pltbl[ii].norm[0] << ", " << TempMesh[i].data.pltbl[ii].norm[1] << ", " << TempMesh[i].data.pltbl[ii].norm[2] << "}, ";
            ofile << "VERTICES{" << TempMesh[i].data.pltbl[ii].Vertices[0] << ", " << TempMesh[i].data.pltbl[ii].Vertices[1] << ", " << TempMesh[i].data.pltbl[ii].Vertices[2] << ", " << TempMesh[i].data.pltbl[ii].Vertices[3] << "},\n";
        }
        ofile << "};\n\n";
    }
    ofile.close();

    return 1;
}




#endif
