#ifndef __MAP2BIN_H__
#define __MAP2BIN_H__

void readBin(string filename);
void readBin_textures(string inFolder, string filename);
void write_map_to_bin(string inFolder, string filename);
//void write_textures(string inFolder, string filename);
void write_textures(string inFolder, ofstream * binFile);

/********************************
* WIP : Writes data to custom binary format
*********************************/
void write_map_to_bin(string inFolder, string filename)
{
    generate_BB_hitbox(filename.c_str());

    cout << "\nWRITE MAP TO BIN - Beta\n";
    string fileOutName = filename + ".ZTM";  //Z-Treme map custom binary file format
    ofstream binFile(fileOutName.c_str(), ios::out | ios::binary);

    /***** Writes to .txt just for testing and ensuring it's right *****/
    //fileOutName = filename + ".txt";
    //ofstream oTestFile(fileOutName.c_str(), ios::out);


    if (!binFile.is_open()) {cout << "\nERROR WHILE WRITING BINARY FILE!\n"; return;}

    binFile.write((char*)&total_mesh, sizeof(unsigned int));
                                                                                //oTestFile << total_mesh << "\n";

    for (unsigned int i=0; i<total_mesh; i++)
    {
        int BSPVal = 0;
        BSPVal = BSP_BB[i].MinValue.x-100;
        binFile.write((char*)&BSPVal, sizeof(int));       //oTestFile << BSP_BB[i].MinValue.x << " ";
        BSPVal = BSP_BB[i].MaxValue.x +200 - BSP_BB[i].MinValue.x;
        binFile.write((char*)&BSPVal, sizeof(int));                     //oTestFile << BSPVal << " ";
        BSPVal = BSP_BB[i].MinValue.y - 100;
        binFile.write((char*)&BSPVal, sizeof(int));       //oTestFile << BSP_BB[i].MinValue.y << " ";
        BSPVal = BSP_BB[i].MaxValue.y + 200 - BSP_BB[i].MinValue.y;
        binFile.write((char*)&BSPVal, sizeof(int));                     //oTestFile << BSPVal << " ";
        BSPVal = BSP_BB[i].MinValue.z - 100;
        binFile.write((char*)&BSPVal, sizeof(int));       //oTestFile << BSP_BB[i].MinValue.z << " ";
        BSPVal = BSP_BB[i].MaxValue.z + 200 - BSP_BB[i].MinValue.z;
        binFile.write((char*)&BSPVal, sizeof(int));                    // oTestFile << BSPVal << "\n";


        binFile.write((char*)&mesh_array[i].data.nbPoint, sizeof(unsigned int));
                                                                                //oTestFile << mesh_array[i].data.nbPoint << "\n";
        binFile.write((char*)&mesh_array[i].data.nbPolygon, sizeof(unsigned int));
                                                                                //oTestFile << mesh_array[i].data.nbPolygon << "\n";
        for (unsigned int j=0; j<mesh_array[i].data.nbPoint; j++)
        {
            for (int ii=0; ii < 3; ii++)
            {
                binFile.write((char*)&mesh_array[i].data.pntbl[j][ii], sizeof(int));
                                                                               // oTestFile << mesh_array[i].data.pntbl[j][ii] << "\n";
            }
        }
        for (unsigned int j=0; j<mesh_array[i].data.nbPolygon; j++)
        {
            for (int ii=0; ii<3; ii++)
            {
                binFile.write((char*)&mesh_array[i].data.pltbl[j].norm[ii], sizeof(int));
                                                                               // oTestFile << mesh_array[i].data.pltbl[j].norm[ii] << "\n";
            }
            for (int ii=0; ii<4; ii++)
            {
                binFile.write((char*)&mesh_array[i].data.pltbl[j].Vertices[ii], sizeof(unsigned short));
                                                                               // oTestFile << mesh_array[i].data.pltbl[j].Vertices[ii] << "\n";
            }
        }
        for (unsigned int j=0; j<mesh_array[i].data.nbPolygon;j++)
        {
            int texno = mesh_array[i].data.attbl[j].texno;
            if (texno < 0) texno = 0;
            binFile.write((char*)&texno, sizeof(unsigned int));
                                                                               // oTestFile << texno << "\n";
        }
    }

    write_textures(inFolder, &binFile);
    binFile.close();
   // oTestFile.close();





//readBin(filename);
//write_textures(inFolder, filename);
}


void write_textures(string inFolder, ofstream * binFile)
{
    //string fileOutName = inFolder + "TEST.ZTT";  //Temporary, I want to include it directly in the ZTM file, but need to do more tests first
    //ofstream binFile(fileOutName.c_str(), ios::out | ios::binary);

    unsigned int buf = TexturePtr;
    binFile->write((char*)&buf, sizeof(unsigned int));
    for (int i=0; i<TexturePtr; i++)
    {
        ReadTGAFile(inFolder, TextureArray[i], i);
        unsigned int w=0; unsigned int h=0;
        w = img[i].width; h = img[i].height;
        binFile->write((char*)&w, sizeof(unsigned int));
        binFile->write((char*)&h, sizeof(unsigned int));

        int ii=0;//(img[i].width*img[i].height)-1;
        for (int h=img[i].height; h>0; h--)
        {
            for (int w=0; w<img[i].width; w++)
            //for (int w=img[i].width-1; w>=0; w--)
            /*** Need more testing, might have to reverse back the textures  ****/
            {

                buf = 0;
                buf = img[i].data[ii+w];
                binFile->write((char*)&buf, sizeof(unsigned short));
            }
            ii+=img[i].height;
        }

    }
 //   readBin_textures(inFolder, filename);
}


/*** Don't use for now ***/
void readBin_textures(string inFolder, string filename)
{
    string fileOutName = inFolder + "CONF.TXT";
    ofstream ofile(fileOutName.c_str(), ios::out);
    fileOutName = inFolder + "TEST.ZTT";
    ifstream ibinfile(fileOutName.c_str(), ios::out | ios::binary);
    if (!ibinfile.is_open()) return;

   // unsigned int idx =0;
    unsigned int totalTEX=0;
    unsigned int width=0; unsigned int heigth=0; unsigned int colordata=0;

    ibinfile.read((char*)&totalTEX, sizeof(unsigned int));
    ofile << "Total textures : " << totalTEX << "\n";
    for (unsigned int i=0; i<totalTEX; i++)
    {
        //idx=0;
        ibinfile.read((char*)&width, sizeof(unsigned int));
        ibinfile.read((char*)&heigth, sizeof(unsigned int));
        ofile << "\n" << TextureArray[i] << ", resolution : " << width << "x" << heigth << "\n";
        for (unsigned int h=0; h< heigth; h++)
        {
            for (unsigned int w=0; w<width; w++)
            {
                ibinfile.read((char*)&colordata, sizeof(unsigned int));
                ofile << colordata << " ";
            }
            ofile << "\n";
        }
    }

    ibinfile.close();
    ofile.close();

}


/*********
To confirm the binary file works. (NOTE : I didn't update this function, don't use it or the program will crash!)
TODO : Allow conversion from Z-TREME binary files to normal Jo Engine header files
*********/
/*
void readBin(string filename)
{
    string name;
    name =  filename + ".ZTM"; //Z-Treme Map custom binary file format
    ifstream ibinfile(name.c_str(), ios::in | ios::binary); //| ios::ate);


    name = filename + "_RESULT.txt";
    ofstream oTestFile(name.c_str(), ios::out);


    unsigned int mesh_tot = 0;
    unsigned int nbpoint = 0;
    unsigned int nbpolygon = 0;
   // unsigned int MeshSize = 0;
    //unsigned int read_int;
    //ifstream inBinFile(filename.c_str(), ios::in | ios::binary);
    if (!ibinfile.is_open()) return;
    oTestFile << "Filename : " << filename.c_str() << "\n";

    ibinfile.read((char*)&mesh_tot, sizeof(unsigned int));
    oTestFile << "TOTAL MESHES : " << mesh_tot << "\n";

    for (unsigned int i=0; i<mesh_tot; i++)
    {
        if (ibinfile.eof()) break;
        oTestFile << "MESH No." << i << "\n";
        //ibinfile.read((char*)&MeshSize, sizeof(unsigned int));
        //oTestFile << "Size of mesh No." << i << " : " << MeshSize << "\n";
        ibinfile.read((char*)&nbpoint, sizeof(unsigned int));
        oTestFile << nbpoint << "\n";
        ibinfile.read((char*)&nbpolygon, sizeof(unsigned int));
        oTestFile << nbpolygon << "\n";

        for (unsigned int ii=0; ii<nbpoint; ii++)
        {
            int curpoint = 0;

            oTestFile << "POINT No." << ii << "(";
            for (int iii=0; iii<3; iii++)
            {
                ibinfile.read((char*)&curpoint, sizeof(int));
                if (iii!=2) oTestFile << curpoint << ", ";
                else oTestFile << curpoint;
            }
            oTestFile << ");\n";
        }
        for (unsigned int ii=0; ii<nbpolygon; ii++)
        {
            int curNorm = 0;
            unsigned short curVert = 0;

            oTestFile << "Polygon : " << ii << " Normals(";
            for (int iii=0; iii<3; iii++)
            {
                ibinfile.read((char*)&curNorm, sizeof(int));
                if (iii!=2) oTestFile << curNorm << ", ";
                else oTestFile << curNorm;
            }
            oTestFile << "), Vertices(";
            for (int iii=0; iii<4; iii++)
            {
                ibinfile.read((char*)&curVert, sizeof(unsigned short));
                if (iii!=3) oTestFile << curVert << ", ";
                else oTestFile << curVert;
            }
            oTestFile << ");\n";
        }
        for (unsigned int ii=0; ii<nbpolygon; ii++)
        {
            unsigned short curAttr = 0;
            oTestFile << "ATTRIBUTE(TEXNO : ";
            ibinfile.read((char*)&curAttr, sizeof(unsigned short));
            oTestFile << curAttr << ");\n";
        }
        oTestFile << "END OF MESH NO." << i << "\n";
    }

        ibinfile.close();
        oTestFile.close();
}*/


#endif
