#ifndef __OBJ2SGL_H
#define __OBJ2SGL_H

#include <string>
#include <sstream>
#include <iostream>
#include <fstream>
#include <stdio.h>

#include "Def.h"


using namespace std;


int total_loaded_meshes = 0;
//int pointer = 0;


typedef struct
{
    POINT	pntbl[20000];
    Uint32	 nbPoint;
    POLYGON	pltbl[20000];
    Uint32	 nbPolygon;
    ATTR	attbl[20000];
} temp_data;

typedef struct
{
    temp_data data;
} _temp_mesh;

typedef struct
{
    int vertnorm[3];
} _temp_normals;


_temp_mesh ObjMesh[128]={0};
_temp_normals vertNorm[20000]; //High number, won't happen. Since the Obj file seperates normals from faces, we will store them in an array
int MeshPtr=0;
int TexturePtr=0;
string TextureArray[300]={""};

int generate_texture_list(string inString)
{
    if (inString=="None") return -1;
    for (int i=0; i<TexturePtr; i++)
    {
        if (inString == TextureArray[i])
        {
            cout << "Duplicated texture. Merging\n";
            return i;
        }
    }
    cout << "Added new texture to the texture list\n";
    TextureArray[TexturePtr] = inString;
    TexturePtr++;
    return TexturePtr-1;
}

/* For testing purposes, will be removed  */
void write_texture_list(string filename)
{
    ofstream file("OUT/TEXTURELIST.txt", ios::out);
    if (!file.is_open()) {cout << "ERROR TRYING TO WRITE THE TEXTURE LIST FILE\n"; return;}
    for (int i=0; i<TexturePtr; i++)
    {
        file << i << " " << TextureArray[i] << "\n";
    }
    file.close();
}

void sort_faces(string inString, int MeshPtr, int index, int total_verts, int total_normals)
{

            string f1, f2, f3;

            char bufferChar[128]={}; //Don't ask, I'm more used to C than C++, so just went "fuck it"....
            int i = 0;
            for (i=0; i<128; i++)
            {
                if (inString[i]=='/') {i++; break;}
                bufferChar[i]=inString[i];
            }
            f1 = bufferChar;
            int charPtr=0;            char bufferChar2[128]={};            f2 = "";
            for (i; i<128; i++)
            {
                if (inString[i]=='/') {i++; break;}
                bufferChar2[charPtr]= inString[i];
                charPtr++;
            }
            f2 = bufferChar2;
            charPtr=0; char bufferChar3[128]={}; f3 = "";
            for (i; i<128; i++)  /*** The compiler will say that it's useless, but i just continues from the other lines, so don't change it!  ***/
            {
                if (inString[i]=='/') {i++; break;}
                bufferChar3[charPtr]=inString[i];
                charPtr++;
            }
            f3=bufferChar3;

  //cout << "F1 " << f1 << " F2 " << f2 << " F3 " << f3 << "\n";
  int i1,  i2, i3;
  if (f1 != "")   i1 = std::stoi(f1) - 1;
  else (i1 = 0);
  if (f2 != "") i2 = std::stoi(f2) - 1;
  else (i2 = 0);
  if (f3 != "") i3 = std::stoi(f3) - 1;
  else (i3 = 0);

  ObjMesh[MeshPtr].data.pltbl[ObjMesh[MeshPtr].data.nbPolygon].Vertices[index] = i1 - total_verts;
  //ObjMesh[MeshPtr].data.attbl[ObjMesh[MeshPtr].data.nbPolygon].texno = i2;  AFAIK i2 is useless since the Saturn doesn't support texture coord
  ObjMesh[MeshPtr].data.pltbl[ObjMesh[MeshPtr].data.nbPolygon].norm[0] = vertNorm[i3-total_normals].vertnorm[0];
  ObjMesh[MeshPtr].data.pltbl[ObjMesh[MeshPtr].data.nbPolygon].norm[1] = vertNorm[i3-total_normals].vertnorm[1];
  ObjMesh[MeshPtr].data.pltbl[ObjMesh[MeshPtr].data.nbPolygon].norm[2] = vertNorm[i3-total_normals].vertnorm[2];
}




bool load_OBJ_to_mesh(ifstream *file, float scalefactor)
{
    string line;
    int pointer = 0;
    int textpointer = -1;
    int bufTotalNorm = 0;
    int TotalNorms=0;
    int bufTotalVerts = 0;
    MeshPtr = -1;
    //for (int i=0; i<500; i++)
    //{
        //    ObjMesh[i].data.nbPoint = 0; ObjMesh[i].data.nbPolygon=0;
            //for (int )
    //}

    if (!file->is_open()) return false;
    file->seekg(pointer, ios::beg);
    while(!file->eof())
    {
        getline(*file, line);
        if ((line[0] == 'o' && line[1] == ' ') || (line[0]== 'g'))
        {
            if (MeshPtr>=0) bufTotalVerts += ObjMesh[MeshPtr].data.nbPoint;
            TotalNorms+=bufTotalNorm;
            bufTotalNorm=0;
            MeshPtr++;
            stringstream NameSS(line);
            string uselessbuffer;
            getline(NameSS, uselessbuffer, ' ');
            //NameSS >> ObjMesh->mesh_name;
            cout << ".OBJ MESH No." << MeshPtr << "\n";
            ObjMesh[MeshPtr].data.nbPoint = 0;
            ObjMesh[MeshPtr].data.nbPolygon = 0;
            //ObjMesh->filePtr = i;

            /*** Not sure yet if I need to reset the total norm***/
        }
        else if (line[0] == 'v' && line[1] == ' ')
        {

            stringstream PointSS(line);
            string uselessbuffer;
            getline(PointSS, uselessbuffer, ' ');
            string sx = ""; string sy = ""; string sz = "";
            PointSS >> sx >> sy >> sz;
            //cout << sx << " " << sy << " " << sz << "\n";

            float fx = std::stof(sx);            float fy = std::stof(sy);            float fz = std::stof(sz);
            int ix, iy, iz;
            ix = fx*65536.0*scalefactor; iy = fy*65536.0*scalefactor; iz=fz*65536.0*scalefactor;

            ObjMesh[MeshPtr].data.pntbl[ObjMesh[MeshPtr].data.nbPoint][0] = ix;
            ObjMesh[MeshPtr].data.pntbl[ObjMesh[MeshPtr].data.nbPoint][1] = iy;
            ObjMesh[MeshPtr].data.pntbl[ObjMesh[MeshPtr].data.nbPoint][2] = iz;
            ObjMesh[MeshPtr].data.nbPoint ++;
        }
        else if (line[0]== 'v' && line[1]== 'n')
        {
            stringstream NormSS(line);
            string bufferStr;
            getline(NormSS, bufferStr, ' ');
            string sx, sy, sz;
            NormSS >> sx >> sy >> sz;
            float fx = std::stof(sx);            float fy = std::stof(sy);            float fz = std::stof(sz);
            int ix, iy, iz;
            ix = fx*65536.0; iy = fy*65536.0; iz=fz*65536.0;
            cout << "Normal :" << ix << " " << iy << " " << fz << "\n";
            vertNorm[bufTotalNorm].vertnorm[0] = ix;
            vertNorm[bufTotalNorm].vertnorm[1] = iy;
            vertNorm[bufTotalNorm].vertnorm[2] = iz;
            bufTotalNorm++;
        }
        else if (line[0]== 'm') //material library, not implemented for now
        {

        }
        else if (line[0]== 's')  //Shader? Not implemented
        {

        }
        else if (line[0]=='u' && line[1]=='s' && line[2]=='e' && line[3]=='m' && line[4]=='t' && line[5]=='l') //Yeah, I know we all got it after the 2 letters, but just in case some weird Obj format popup...
        {
            stringstream MtlSS(line);         string bufferStr;
            getline(MtlSS, bufferStr, ' ');
            string mtlName = {""};
            MtlSS >> mtlName;
            textpointer=generate_texture_list(mtlName);

            cout << "Detected texture/material named " << mtlName << "\n";

        }

        /*******   VERY UGLY, I know! ****************/
        else if (line[0] == 'f' && line[1] == ' ')
        {
            stringstream FaceSS(line);
            string bufferStr;
            getline(FaceSS, bufferStr, ' ');
            string p[4];
            FaceSS >> p[0] >> p[1] >> p[2] >> p[3];
            if (p[3]=="") {p[3]=p[2]; cout << "Triangle detected. Merging point 4 with point 3\n";}
            //stringstream tempP1(p1); stringstream tempP2(p2); stringstream tempP3(p3); stringstream tempP4(p4);
            sort_faces(p[0], MeshPtr, 0, bufTotalVerts, TotalNorms);
            sort_faces(p[1], MeshPtr, 1, bufTotalVerts, TotalNorms);
            sort_faces(p[2], MeshPtr, 2, bufTotalVerts, TotalNorms);
            sort_faces(p[3], MeshPtr, 3, bufTotalVerts, TotalNorms);

            if (textpointer != -1) ObjMesh[MeshPtr].data.attbl[ObjMesh[MeshPtr].data.nbPolygon].texno = textpointer; //Seems like 0 = No_Texture in SGL
            else ObjMesh[MeshPtr].data.attbl[ObjMesh[MeshPtr].data.nbPolygon].texno = 0;

            ObjMesh[MeshPtr].data.nbPolygon++;
        }
        pointer++;
    }

    file->clear();

    return true;
}


void clearTextures(void)
{
    for (int i=0; i<TexturePtr; i++)
    {
        TextureArray[i]="";
    }
    TexturePtr=0;
}

#include "MAPBSP.h"




/***** Converts .OBJ files to SGL PDATA *****/
int Obj2SGL(string filename, float scalefactor, vector3 subdividefactor, bool subdivide)  //Return the total amound of meshes if it doesn't fail
{
    clearTextures();  //Note that it doesn't overwrite previous textures, only the list. So if your texture folder doesn't contain textures, it will just use last textures

    ifstream file(filename, ios::in | ios::ate);
    if (!file.is_open()) {cout << "ERROR READING OBJ FILE\n"; exit(-1);}
    if (load_OBJ_to_mesh(&file, scalefactor)) {cout << "Obj loaded...\n";}
    else {cout << "Couldn't load Obj\n"; return - 1;}
    file.close();

    if (subdivide==true) subdivideObj(subdividefactor.x, subdividefactor.y, subdividefactor.z);  /*** Function in MAPBSP.h ***/

    MeshPtr++; //I screw up with the load_Obj by not having a total Mesh value and using a pointer, so we "correct" this here.
    cout << "MeshPtr : " << MeshPtr << "\n";
    for (int i=0; i< MeshPtr; i++)
    {
        mesh_array[i].data.nbPoint=ObjMesh[i].data.nbPoint;
        cout << mesh_array[i].data.nbPoint << " ";
        mesh_array[i].data.nbPolygon=ObjMesh[i].data.nbPolygon;
        cout << mesh_array[i].data.nbPolygon << "\n";
        //for (unsigned int ii=0; ii<ObjMesh[i].data.nbPoint; ii++) /**** No effect, to be removed after some more tests ****/
        //{
            mesh_array[i].data.pntbl= ObjMesh[i].data.pntbl;
        //}
        //for (unsigned int ii=0; ii<ObjMesh[i].data.nbPolygon; ii++)  /**** No effect****/
        //{
            mesh_array[i].data.pltbl=ObjMesh[i].data.pltbl;
            mesh_array[i].data.attbl=ObjMesh[i].data.attbl;
        //}

    //cout << "Mesh ID : " << i << "  nbPoint : " <<    mesh_array[i].data.nbPoint << " nbPolygon : " << mesh_array[i].data.nbPolygon << "\n";
    }


    write_texture_list(filename);


    return MeshPtr;
}








#endif
